Const

     MaxXCross                       = 3;

     MaxCCopy                        = 6;

     MaxMsgSwitch                    = 13;

     MaxScanArea                     = 7;

     MaxNumCookies                   = 128;

Type

  MsgDateTime     = Array[0..19] of Char;

  CookieIndexType = Array[0..1023] of record
                                        Ofs: LongInt;
                                        Len: Byte;
                                      end;

  ScanAreaType    = Record
                      Area      : String[63]; { H         }
                      Dir       : String[80]; { pp       }
                      Magic     : String[12]; {  "ᥢ뢮" }
                    end;

  StoredMSGHeader = Record
      FromUser  : Array[0..35] of Char; { FromUserName (0) }
      ToUser    : Array[0..35] of Char; { ToUserName   (0) }
      Subject   : Array[0..71] of Char; { Subject      (0) }
      DateTime  : MsgDateTime;          { TextDateTime (0) }
      TimesRead : Word;                 { Times Read       }
      DestNode  : Word;                 { Dest. Node       }
      OrigNode  : Word;                 { Orig. Node       }
      Cost      : Word;                 { Cost             }
      OrigNet   : Word;                 { Orig. Net        }
      DestNet   : Word;                 { Dest. Net        }
      DestZone  : Word;                 { Dest. Zone       }
      OrigZone  : Word;                 { Orig. Zone       }
      DestPoint : Word;                 { Dest. Point      }
      OrigPoint : Word;                 { Orig. Point      }
      ReplyTo   : Word;                 { Reply to...      }
      Attribute : Word;                 { Attribute        }
      NextReply : Word;                 { Next reply       }
    end;

  PktMSGHeader    = record
      Constant2 : Word;                 { $0002            }
      OrigNode  : Word;                 { Orig. Node       }
      DestNode  : Word;                 { Dest. Node       }
      OrigNet   : Word;                 { Orig. Net        }
      DestNet   : Word;                 { Dest. Net        }
      Attribute : Word;                 { Attributes       }
                  { Bit  0  +    Private
                    Bit  1  + s  Crash
                    Bit  2       Recd
                    Bit  3       Sent
                    Bit  4  +    FileAttached
                    Bit  5       InTransit
                    Bit  6       Orphan
                    Bit  7       KillSent
                    Bit  8       Local
                    Bit  9    s  HoldForPickup
                    Bit 10  +    unused
                    Bit 11    s  FileRequest
                    Bit 12  + s  ReturnReceiptRequest
                    Bit 13  + s  IsReturnReceipt
                    Bit 14  + s  AuditRequest
                    Bit 15    s  FileUpdateReq

                              s - need not be recognized, but
                                  it's ok
                            + - not zeroed before packeting
                     }
      Cost      : Word;                 { Cost             }
      DateTime  : MsgDateTime;          { TextDateTime (0) }
      ToUser    : String[35];           { To UserName  (0) }
      FromUser  : String[35];           { From UserName(0) }
      Subject   : String[71];           { Subject      (0) }
      Message   : PChar;                { Adr of Message   }
    end;

  PktFileHeader   = record
      Case byte of
      0 : (OrigNode   : Word;  { Originating Node Number             0 : 2 }
           DestNode   : Word;  { Destination Node Number             2 : 2 }
           Year       : Word;  { 2 /2+ - Year of packet created      4 : 2 }
                               { 2.2   - Originating Point Number    4 : 2 }
           Month      : Word;  { 2 /2+ - Month of packet created     6 : 2 }
                               { 2.2   - Destination Point Number    6 : 2 }
           Day        : Word;  { 2 /2+ - Day of packet created       8 : 2 }
                               { 2.2   - Reserved = 0                8 : 8 }
           Hour       : Word;  { 2 /2+ - Hour of packet created     10 : 2 }
           Min        : Word;  { 2 /2+ - Minute of packet created   12 : 2 }
           Sec        : Word;  { 2 /2+ - Seconds of packet created  14 : 2 }
           Baud       : Word;  { 2 /2+ - Baud (use 0)               16 : 2 }
                               { 2.2   - Packet Sub Version (2)     16 : 2 }
           PktType    : Word;  { 2 /2+ - Packet Version (2)         18 : 2 }
                               { 2.2   - Packet Version (2)         18 : 2 }
           OrigNet    : Word;  { 2 /2+ - Originating Network
                                   /2+ - if Origin - point = -1     20 : 2 }
                               { 2.2   - Originating Network        20 : 2 }
           DestNet    : Word;  { 2 /2+ - Destination Network        22 : 2 }
                               { 2.2   - Destination Network        22 : 2 }
           ProdCode   : Byte;  {   /2+ - ProductCode (FTSC product) 24 : 2 }
                               { 2.2   - ProductCode (FTSC product) 24 : 1 }
           SerialNo   : Byte;  {   /2+ - Product revision level
                                         (Relise version)           25 : 1 }
                               { 2.2   - Product revision level
                                         (Relise version)           25 : 1 }
           Password   : Array[0..7] of Char;
                               { 2 /2+ - Packet password            26 : 8 }
                               { 2.2   - Packet password            26 : 8 }
           OrigZone   : Word;  { 2 /2+ - Originating Zone           34 : 2 }
                               { 2.2   - Originating Zone           34 : 2 }
           DestZone   : Word;  { 2 /2+ - Destination Zone           36 : 2 }
                               { 2.2   - Destination Zone           36 : 2 }
           AuxNet     : Word;  {   /2+ - Contains OrigNet if
                                         Origin is a point          38 : 2 }
                               { 2.2   - Originating Domain         38 : 8 }
           CapValid   : Word;  {   /2+ - Byte-swapped copy of
                                         Compatibility Word         40 : 2 }
           ProdCode2  : Byte;  {   /2+ - Product Code (Hi)          42 : 1 }
           SerialNo2  : Byte;  {   /2+ - Revision level (Low)       43 : 1 }
           CapWord    : Word;  {   /2+ - Compatibility Word         44 : 2 }
           FromZone   : Word;  {   /2+ - Originating Zone           46 : 2 }
                               { 2.2   - Destination Domain         46 : 8 }
           ToZone     : Word;  {   /2+ - Destination Zone           48 : 2 }
           OrigPoint  : Word;  {   /2+ - Originating Point          50 : 2 }
           DestPoint  : Word;  {   /2+ - Destination Point          52 : 2 }

           ProdData1  : Word;  {   /2+ - Product Data (ignored)     54 : 2 }
                               { 2.2   - Product Data (ignored)     54 : 2 }
           ProdData2  : Word   {   /2+ - Product Data (ignored)     56 : 2 }
                               { 2.2   - Product Data (ignored)     56 : 2 }
           );
      1 : (Binary     : Array[0..57] of Byte
           );
    end;

  FidoAddress    = record
                    Zone,
                    Net,
                    Node,
                    Point  : Word;
                    Domain : String[40];
                   end;

  FidoAddressArray = Array [0..9] of FidoAddress;

  Msg_Header    = record
                   FromName : Array[1..36] of Char;
                  end;

  CarbonType    = record
                    Name       : String[36];
                    Adr        : FidoAddress;
                    ViewInList : Boolean;
                  end;

  CarbonTypeArray = Array [0..255] of CarbonType;

  AreasArray    = Array [0..MaxXCross] of
                    record
                      N          : String[74];
                      ViewinList : Boolean;
                    end;

  StringArray   = Array [0..803] of String[79];
